# Overview

This deploys a Daemonset on each Openshift node to collect container logs and system logs (i.e. /var/log/messages).

This is derived from Openshift's [aggregated logging](https://docs.openshift.org/3.6/install_config/aggregate_logging.html)
adapted for [CERN Central Monitoring](https://cern.ch/monitdocs)

This should work with both json and journald Docker log drivers.
The json log driver is the [recommended setting](https://docs.openshift.org/latest/install_config/aggregate_logging.html#fluentd-update-source)
and should be used on Openshift nodes deployed with openshift-ansible as of Openshift 3.9.

## How this was built

We're taking the fluentd part of Openshift's [aggregated logging](https://docs.openshift.org/3.6/install_config/aggregate_logging.html)
and modify the fluentd configuration files to send events to CERN Central Monitoring instead of an Elastic Search instance in Openshift.

Step by step:
1. in a test cluster, deploy [aggregated logging](https://docs.openshift.org/3.9/install_config/aggregate_logging.html). This will
deploy elastic search, Kibana and fluentd. By default it all goes to a `logging` namespace.
  ```
  # e.g. using the paas-tools Ansible image:
  # import the ansible hosts file for the test cluster
  ansible-playbook ./byo/openshift-cluster/openshift-logging.yml -e openshift_logging_install_logging=true
  ```
1. export the `logging-fluentd` daemonset. This will be the base for this project.
1. modify slightly the daemonset:
  1. replace the `ES_*` environment variables with dummy values as we won't actually be sending to ES (but the fluentd image still expects them). Use `/dev/null` for certificate file paths.
  1. remove the `certs` secret volume as we don't need certificates to talk with ES
  1. add `CERN_MONIT_*` environment variables
1. export the `logging-fluentd` configmap, which we'll modify to reroute events to central monitoring.
  Of the 3 files in the original `logging-fluentd` configmap, only `fluent.conf` actually is useful;
  `secure-forward.conf` and `throttle-config.yaml` only have comments. See the next section for the exact changes in config files.
1. we'll need an extra `fluentd-scripts` configMap to store extra scripts required to send data to Central Monitoring

## Fluentd configuration for Central Monitoring

The contents of the `logging-fluentd` configmap generated by the [upstream aggregated logging project](https://github.com/openshift/origin-aggregated-logging)
are split into individual files the [./fluentd-config/](./fluentd-config/) folder.

These files get injected in the fluentd pod in `/etc/fluentd/configs.d/user` (with `fluentd.conf` moved to `/etc/fluentd`
by the upstream pod startup script)

* `[fluent.conf](./fluentd-config/fluent.conf)` is the main config file. We modify the `@OUTPUT` pipeline to reroute events
to a new pipeline that will send them to Central Monitoring instead

The original `fluent.conf` has:

```
<label @OUTPUT>
## matches
    @include configs.d/openshift/output-pre-*.conf
    @include configs.d/openshift/output-operations.conf
    @include configs.d/openshift/output-applications.conf
    # no post - applications.conf matches everything left
##
</label>
```

We insert `@include configs.d/user/[output-cernmonit.conf](./fluentd-config/output-cernmonit.conf)`
before `output-operations.conf/output-applications.conf` (which send to the default ES instance running in Openshift)
to reroute events to our custom pipeline `@CERNMONIT_RETAG`.

Then we add two custom pipelines:

```
<label @CERNMONIT_RETAG>
    # we first need to retag events in a way convenient for the CERNMONIT pipeline.
    # retagged events are then sent to the CERNMONIT pipeline.
    @include configs.d/user/cernmonit-retag.conf
</label>

<label @CERNMONIT>
    ## filtering phase
    # filter behavior can be modified by adding extra files in the configmap which are included here
    @include configs.d/user/cernmonit-filter-pre-*.conf
    # cernmonit-filter-format-monit reformats events for submission to Central Monitoring
    @include configs.d/user/cernmonit-filter-format-monit.conf
    # filter behavior can be modified by adding extra files in the configmap which are included here
    @include configs.d/user/cernmonit-filter-post-*.conf

    ## output phase
    # output behavior can be modified by adding extra files in the configmap which are included here
    @include configs.d/user/cernmonit-output-pre-*.conf
    # send what's left to central monitoring
    @include configs.d/user/cernmonit-output-send-monit.conf
</label>
```

* `[output-cernmonit.conf](./fluentd-config/output-cernmonit.conf)` simply reroutes all events to the `@CERNMONIT_RETAG` pipeline.
It also supports the optional `[secure-forward.conf](./fluentd-config/secure-forward.conf)` file as upstream does.

* `[cernmonit-retag.conf](./fluentd-config/cernmonit-retag.conf)` retags events and sends them to the `@CERNMONIT` pipeline.
For pod container logs, we tag them `containerlog.<namespace>`, this allows to process different namespaces differently
(e.g. filter out some namespaces).
For system logs we tag `systemlog.<systemd unit>`.

* `[cernmonit-filter-format-monit.conf](./fluentd-config/cernmonit-filter-format-monit.conf)` reorganizes event properties so they
match what [Central Monitoring expects](http://monitdocs.web.cern.ch/monitdocs/ingestion/service_logs.html)

* `[cernmonit-output-send-monit.conf](./fluentd-config/cernmonit-output-send-monit.conf)` sends the final events to Central Monitoring
over HTTP. For this we need an external script injected by the `fluentd-scripts` configmap: `[sendmonit.sh](./fluentd-scripts/sendmonit.sh)`.

* `cernmonit-filter-pre-*.conf`, `cernmonit-filter-post-*.conf` and `cernmonit-output-pre-*.conf` files can be dropped in
the [./fluentd-config/](./fluentd-config/) folder to customize the pipeline behavior at various phases.
Typically to exclude certain pods/namespaces from logging because they are too verbose.

* `[secure-forward.conf](./fluentd-config/secure-forward.conf)` and `[throttle-config.conf](./fluentd-config/throttle-config.conf)`
are kept as-is from upstream. They allow to optionally add extra behaviour.

## Troubleshooting

The test Openshift cluster can be used for playing and troubleshooting.

E.g. to print the events on the fluentd pod's STDOUT, uncomment the `stdout` store in
[`output-cernmonit.conf`](fluentd-config/output-cernmonit.conf)

See also https://docs.fluentd.org/v1.0/articles/logging (but need to modify the upstream `system.conf`)


# Tuning what is sent to Central Monitoring and what is not

This is critical to keep log volume to an acceptable level. Some applications may be too verbose to we can keep
their logs.

Openshift filters out some logs already
(e.g. [the fluentd pod logs themselves](https://github.com/openshift/origin-aggregated-logging/commit/aaa5751319ff0666a4a3b40d27e63f3c5913e744#diff-66c3bd33e5e78bb6eee2bbd5de081ac6R67))

We can further customize what is filtered out by adding files `fluentd-config/cernmonit-filter-post-*.conf`.
See for instance [fluentd-config/cernmonit-filter-post-exclude-gitlab.conf](fluentd-config/cernmonit-filter-post-exclude-gitlab.conf)

We can also leverage per-project log throttling: https://github.com/openshift/origin-aggregated-logging/blob/master/docs/log-drivers-and-throttling.md#log-throttling

# Deployment

## Initial deployment

To deploy to a new cluster, in the `paas-infra` namespace:

```bash
# select the proper environment to use correct template parameters
environment=prod # or dev

# create a serviceaccount
oc create serviceaccount aggregated-logging-fluentd -n paas-infra
oc label serviceaccount aggregated-logging-fluentd -n paas-infra \
    app="cern-aggregated-logging"
oc annotate serviceaccount aggregated-logging-fluentd -n paas-infra \
    description="Used by logging-fluentd daemonset to collect container and system logs and send them to central monitoring"
# we need to be privileged
oc adm policy add-scc-to-user privileged system:serviceaccount:paas-infra:aggregated-logging-fluentd
# add same roles as upstream does
oc adm policy add-cluster-role-to-user cluster-reader system:serviceaccount:paas-infra:aggregated-logging-fluentd
# create configmaps for fluentd config and custom scrips
oc create -n paas-infra configmap logging-fluentd --from-file=./fluentd-config/
oc create -n paas-infra configmap logging-fluentd-scripts --from-file=./fluentd-scripts/
oc label configmap/logging-fluentd configmap/logging-fluentd-scripts -n paas-infra \
    app="cern-aggregated-logging"
# deploy daemonset
oc process --local -f ./deploy/logging-fluentd-template.yaml --param-file=./deploy/parameters/${environment} | \
    oc create -n paas-infra -f -
```

## Automated update with GitLab-CI

Changes in config files and daemonset template are deployed automatically with gitlab-ci
using the group-level secret variables for the paas-infra subgroup.

## Unprovision aggregated logging

Assuming all resources were labelled properly:

```bash
oc delete configmap,serviceaccount,daemonset -n paas-infra -l app=cern-aggregated-logging
```

# Updating to newer Openshift version

* redeploy the upstream aggregated logging in the test cluster and review the `fluent.conf` for any significant changes (unlikely)
* update the image tag in the template to the newer version and let GitLab CI redeploy fluentd.

NB: the upstream deployment configures the daemonset to use the `latest` tag, hence does not bind to a specific version. We might
consider using that tag as well.
